#include "TMath.h"   
#include "TRandom.h"   
#include "RootBox.h"
#include "TROOT.h"
#include <iostream.h>
#include <stream.h>

ClassImp(RootBox)
ClassImp(Traj)
//ClassImp(Iko)

//TClonesArray *RootBox::fgTraj  = 0;
//TClonesArray *RootBox::fgIko  = 0;
  
RootBox::RootBox(){
    Init();
//    if (!fTraj)   fTraj = new TClonesArray("Traj", 1000);
    for(Int_t i=0;i<N;i++)
    {
        fTraj[i] = new TClonesArray("Traj", 100);
    }
    

    
//     if (!fgIko)   fgIko = new TClonesArray("Iko", 100);
//     fIko  = fgIko;    
}
RootBox::~RootBox(){
    cout<<"destructeur"<<endl;
}
void RootBox::Init(){
//    fNtraj           =0;
//    fNiko            =0;
    fRun             =-199;
    fEvent           =-199;
    fTrackID         =-199;
    fParentID        =-199;
    fTrackStatus     =-199;
    fSourcePDGCharge =-199;
    fPDGEncoding     =-199;
    fTrajPoints      =-199;
    fEnergy          =-999;
    fLength          =-999;
    fTime            =-999;
    fMomentum.SetXYZ(0,0,0);    
    fSourcePosition.SetXYZ(0,0,0);    
    fVertexPosition.SetXYZ(0,0,0);
    sprintf(CreatorProc,"Null");

    for(Int_t i=0;i<N;i++)
    {
        fNtraj[i]  = 0;
        fTraj[i]   = 0;
    }
    
}

void RootBox::SuperPrint(){
    cout<<" TrackID         --> "<<fTrackID<<endl;
    cout<<" ParentID        --> "<<fParentID<<endl;
    cout<<" TrackStatus     --> "<<fTrackStatus<<endl;
    cout<<" SourcePDGCharge --> "<<fSourcePDGCharge<<endl;
    cout<<" PDGEncoding     --> "<<fPDGEncoding<<endl;
    cout<<" TrajPoints      --> "<<fTrajPoints<<endl;
    cout<<" Energy          --> "<<fEnergy<<endl;
    cout<<" Length          --> "<<fLength<<endl;
    cout<<" Time            --> "<<fTime<<endl;
    fMomentum.Print();
    fSourcePosition.Print();
    fVertexPosition.Print();
}

Int_t RootBox::GetTrackID()   const
{
    return fTrackID;    
}
Int_t RootBox::GetParentID()   const
{
    return fParentID;    
}

Int_t RootBox::GetTrackStatus()   const
{
    return fTrackStatus;    
}
Int_t RootBox::GetPDGEncoding()  const
{
    return fPDGEncoding;    
}
Int_t RootBox::GetTrajPoints()  const
{
    return fTrajPoints;    
}
Int_t RootBox::GetRun()  const
{
    return fRun;    
}
Int_t RootBox::GetEvent()  const
{
    return fEvent;    
}
Double_t RootBox::GetSourcePDGCharge()  const
{
    return fSourcePDGCharge;    
}
Double_t RootBox::GetEnergy()  const
{
    return fEnergy;    
}
Double_t RootBox::GetVertex()  const
{
    return fLength;    
}
Double_t RootBox::GetGlobalTime()  const
{
    return fTime;    
}
// std::vector<Double_t>  RootBox::GetSTL() const
// {
//     return X;
// }
// Char_t *RootBox::GetCreatorProcess() const
// {
//     return CreatorProc;
// }


TVector3 RootBox::GetMomentum( )  const
{
    return fMomentum;    
}
TVector3 RootBox::GetSourcePosition( )  const
{
    return fSourcePosition;    
}
TVector3 RootBox::GetVertexPosition( )  const
{
    return fVertexPosition;    
}
//______________________________________________________________________________
Traj *RootBox::AddTraj(Int_t trajID)
{
    // Add a new hit to the list of hits in detector B
    TClonesArray &trajs = *fTraj[trajID];
    Traj *traj = new(trajs[fNtraj[trajID]++])Traj();    
    return traj;
}
//______________________________________________________________________________
void RootBox::Build() {

    Int_t ObjectNumber = TProcessID::GetObjectCount();
    Int_t Ntraj=3;
    Traj *traj;
    
    Clear();
    for(Int_t i=0;i<N;i++)
    {
        traj = AddTraj(i);
        for (Int_t j=0;j<Ntraj;j++) {
        traj->fX = i*(j+1);
        traj->fY = i*(j+4);
        traj->fZ = i*(j+412);
        }
    }    
}
//______________________________________________________________________________
void RootBox::Clear(Option_t *option)
{
    for(Int_t i=0;i<N;i++)
    {
        fTraj[i]->Clear(option);
        fNtraj[i]=0;
    }
}
//______________________________________________________________________________
